;--------------------------------------------;
;     TENTO PROGRAM DEMONSTRUJE FUNKCI       ;
;               OPTOPRIJIMACE                ;
;  !spustte si PC aplikaci, ktera prijima!   ;
;        !data pomoci serioveho portu!       ;
;--------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'


	#include	displej.inc
	#include	unibuff.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

MINPULZ	EQU	D'150'	; maximalni delka jednoznacne poruchy

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

BUFF_SIZE	EQU	D'64'

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TML:1
	TMH:1
	DDATA:1
	BUFF_IN:1	; pro obsluhu bufferu
	BUFF_OUT:1
	BUFF_STAT:1
	BUFF_TEMP:1
	BUFF_ADR:BUFF_SIZE
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC
	
	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

	ORG	4
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP
	banksel	0
	; preruseni je vzdy od RBIF
	MOVF	PORTB,F		; "refresujeme" porovnavaci registr
	BCF	INTCON,RBIF	; vynulujeme priznak
	BCF	T1CON,TMR1ON	; zastavime TMR1
	BTFSS	PIR1,TMR1IF	; pokud TMR1 pretekl,...
	GOTO	$ + 4
	CLRF	TMR1H		; ..., potom jej vynulujeme
	CLRF	TMR1L
	BCF	PIR1,TMR1IF
	MOVF	TMR1H,W		; vyssi byte TMR1 vlozime do bufferu
	CALL	IN_BUFF
	MOVF	TMR1H,F		; pokud je vyssi byte nulovy,...
	BTFSS	STATUS,Z
	GOTO	SKOK
	MOVF	TMR1L,W		; ...potom testujeme zda je nulova
	BTFSC	STATUS,Z
	GOTO	SKOK
	SUBLW	MINPULZ		; pokud neni nulova,...
	BTFSS	STATUS,C		; ...testujeme, zda neni prilis mala
	GOTO	SKOK
	CLRF	TMR1L		; pokud je nenulova, ale mala,...
	BSF	PIR1,TMR1IF	; ...potom predstirame chybu v budoucim mereni
SKOK	MOVF	TMR1L,W		; zde vkladame nizsi byte TMR1 do bufferu
	CALL	IN_BUFF
	CLRF	TMR1H		; nulujeme TMR1
	CLRF	TMR1L
	BSF	T1CON,TMR1ON	; TMR1 je spusten

INT_END	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE
	
START	
	banksel	TRISB
	BCF	TRISB,4	; musi byt nastaveno jako vystup
	BCF	TRISB,5
	BCF	TRISB,6
	BSF	TRISB,7	; sem je pripojen optoprijimac
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	BUFFINI 	BUFF_IN, BUFF_OUT,BUFF_STAT

	banksel	T1CON	; nastaveni TMR1 (predelicka 4:1);
	MOVLW	B'00101101'
	MOVWF	T1CON

	; inicializace displeje
	CALL	INITDISP
	; napis: "IR-prijimac"
	MOVLW	D'2'
	CALL	SETPOS
	MOVLW	'I'
	CALL	PUTZNAK
	MOVLW	'R'
	CALL	PUTZNAK
	MOVLW	'-'
	CALL	PUTZNAK
	MOVLW	'p'
	CALL	PUTZNAK
	MOVLW	'r'
	CALL	PUTZNAK
	MOVLW	'i'
	CALL	PUTZNAK
	MOVLW	'j'
	CALL	PUTZNAK
	MOVLW	'i'
	CALL	PUTZNAK
	MOVLW	'm'
	CALL	PUTZNAK
	MOVLW	'a'
	CALL	PUTZNAK
	MOVLW	'c'
	CALL	PUTZNAK

	BSF	INTCON,RBIE
	BSF	INTCON,GIE

LOOP	MOVF	BUFF_STAT,F
	BTFSC	STATUS,Z	; pokud neni buffer prazdny...
	GOTO	LOOP
	MOVLW	D'133'	; ...potom posleme na TX-port hodnotu 133
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	CALL	OUT_BUFF	; ...potom pecteme z bufferu a posleme na port dva byty
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	CALL	OUT_BUFF
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	GOTO	LOOP	; navrat k testovani bufferu

	; ukladani do bufferu
IN_BUFF	INBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 0
	RETURN
	
	; cteni z bufferu
OUT_BUFF	OUTBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 1
	RETURN

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	END
