; OBSLUHA BUFFERU

; poznamka - symbol (*) znaci, ze velicina je pouze adresou promenne

; inicializace bufferu pro zapis (vystupni buffer)
BUFFINI 	MACRO	UKAZIN,UKAZOUT,BUFFSTAT
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
	CLRF	UKAZIN
	CLRF	UKAZOUT
	CLRF	BUFFSTAT
	ENDM

; ulozeni znaku do vystupniho bufferu
INBUFF_	MACRO	BUFFADR, BUFFSIZE, UKAZIN, UKAZOUT, BUFFSTAT, TEMP, GIE_OFF
; BUFFADR - adresa zacatku bufferu
; BUFFSIZE - velikost bufferu
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
; TEMP* - pomocna promenna

	MOVWF	TEMP		; ulozeni vstupu do pomocne promenne
	MOVLW	BUFFSIZE		; kontrola obsahu bufferu
	SUBWF	BUFFSTAT,W
	BTFSC	STATUS,C
	RETURN
	IF GIE_OFF>0
	BCF	INTCON,GIE	; zablokovani systemu preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	ENDIF
	bankisel	BUFFADR		; nastaveni ukazatele
	MOVLW	BUFFADR
	ADDWF	UKAZIN,W
	MOVWF	FSR
	MOVF	TEMP,W		; zapsani znaku do bufferu
	MOVWF	INDF
	banksel	BUFFSTAT
	INCF	UKAZIN,F		; posun ukazatele
	MOVLW	BUFFSIZE
	SUBWF	UKAZIN,W
	BTFSC	STATUS,C
	CLRF	UKAZIN
	INCF	BUFFSTAT,F	; v bufferu je o jeden znak vice
	IF GIE_OFF>0
	BSF	INTCON,GIE	; obnoveni celkoveho systemu preruseni
	ENDIF

	ENDM

OUTBUFF_	MACRO	BUFFADR, BUFFSIZE, UKAZIN, UKAZOUT, BUFFSTAT, TEMP, GIE_OFF
; BUFFADR - adresa zacatku bufferu
; BUFFSIZE - velikost bufferu
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
; TEMP* - pomocna promenna

	MOVF	BUFFSTAT,F	; kontrola obsahu bufferu
	BTFSC	STATUS,Z	
	RETURN
	IF GIE_OFF>0
	BCF	INTCON,GIE	; zablokovani systemu preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	ENDIF
	bankisel	BUFFADR		; nastaveni ukazatele
	MOVLW	BUFFADR
	ADDWF	UKAZOUT,W
	MOVWF	FSR
	MOVF	INDF,W		; precteni znaku z bufferu...
	banksel	TEMP
	MOVWF	TEMP		; ... a ulozeni do pomocne promenne
	INCF	UKAZOUT,F		; posun ukazatele
	MOVLW	BUFFSIZE
	SUBWF	UKAZOUT,W
	BTFSC	STATUS,C
	CLRF	UKAZOUT
	DECF	BUFFSTAT,F	; v bufferu je o jeden znak mene
	MOVF	TEMP,W		; zkopirovani pomocne promenne do W
	IF GIE_OFF>0
	BSF	INTCON,GIE	; obnoveni celkoveho systemu preruseni
	ENDIF

	ENDM
