;---------------------------------------------;
;    TENTO PROGRAM DEMONSTRUJE ZOBRAZENI      ;
;           CISELNE HODNOTY POMOCI            ;
;                  SKRIPTU                    ;
;---------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	displej.inc
	#include	tab_util.inc
	#include	dskripty.inc
	#include	div16u.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

BUFF_SIZE	EQU	D'16'

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TMH:1	; pro obsluhu displeje
	TML:1
	DDATA:1
	NUMFORM_:1
	AA:2
	BB:2
	CC:2
	VD16U:1
	HODNOTA:2
	ENDC

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

START	
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	; inicializace displeje
	CALL	INITDISP

; Nyni bude cyklicky zvysovana 16bitova HODNOTA a soucasne zobrazovana skriptem s indexem 0.
; Promenna HODNOTA neni zvysovana stejnomerne proto, aby jste si mohli dobre prohlednout
;  jak kratka, tak i dlouha cisla...

	CLRF	HODNOTA		; vynulovani zobrazovane promenne
	CLRF	HODNOTA+1
LOOP	MOVLW	D'0'
	CALL	SKRIPT		; zobrazovaci skript cislo "0"
	MOVLW	D'255'		; prodleva...
	CALL	DDELAY
	MOVLW	D'255'
	CALL	DDELAY
	INCF	HODNOTA,W		; pokud by zvysenim doslo k preteceni nizsiho bytu,...
	BTFSC	STATUS,Z
	GOTO	VYSSI		; ...potom prejdeme do rezimu zvysovani o 256
	INCF	HODNOTA,F
	GOTO	LOOP
VYSSI	INCF	HODNOTA+1,W	; pokud by melo dojit k preteceni vyssiho bytu,...
	BTFSC	STATUS,Z
	GOTO	HRESET		; potom bude cela "HODNOTA" vynulovana
	INCF	HODNOTA+1,F
	GOTO	LOOP
HRESET	CLRF	HODNOTA
	CLRF	HODNOTA+1
	GOTO	LOOP

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	; 16bitove deleni
DIV16U	DIV16U_M	AA,BB,CC,VD16U
	
	; provadeni skriptu
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

	ORG	H'800'

TABULKY	DATA	TAB1	; indexacni tabulka s jedinym odkazem

TAB1	POS_D	D'0'			; prvni radek a soucasne prvni znak
	PRINTV	HODNOTA,B'11111',1,0,0,1	; odsazeno bez nul
	DATA	' '
	PRINTV	HODNOTA,B'11110',1,0,1,1	; odsazeno s nulami
	DATA	' '
	PRINTV	HODNOTA,B'11111',1,0,0,0	; neodsazeno
	DBLOK	' ',4			; blok mezer (kvuli prepisovani stareho cisla)
	POS_D	D'64'			; druhy radek
	DE	"desetinne:"
	PRINTV	HODNOTA,B'11100',1,0,0,1	; cela cast cisla (osazeno bez nul)
	DATA	'.'
	PRINTV	HODNOTA,B'00011',1,0,1,1	; desetinna cast (odsazeno s nulami)
	EOFS

	END
